/*-----------------------------
 * iservcon.h
 *
 * Structures & declarations for
 * iservcon.c
 *-----------------------------
 */
/*
 * $RCSfile: iservcon.h,v $
 * $Revision: 1.1 $
 * $Date: 1998/07/31 21:06:11 $
 *
 * $Header: //Iservd/iservcon.h#1 $
 * 
 * $Log: iservcon.h,v $
 * Revision 1.1  1998/07/31 21:06:11  chuckh
 * Initial revision
 *
 */


typedef struct _conInfo {
	int conFlags;				/* Misc. Booleans, see below */
	int conFd;					/* FD of the open socket */
	int conPort;				/* Port for connection, native order */
	int conTry;					/* Which try am I on? */
	int conTotal;				/* How many total tries before give up */
	int conDelay;				/* Seconds to sleep 'tween connection tries */
	int conCloseZZ;				/* Seconds to sleep before close (non-telnet) */
	char conName[SV_MAX];		/* Server name from option */
	struct hostent conHost;		/* Host entry structure */
	struct sockaddr_in conIn;	/* Socket structure */
} coninfo_t;

/* Values for conFlags: */

#define CON_READY	0x1		/* initConnect has been run: we are ready to
							 * try to connect.
							 */
#define CON_OPEN	0x2		/* The socket is open and connected */

#define CON_BINARY	0x4		/* Wants to be a binary connection */
#define CON_PERM	0x8		/* Wants to be a permanent connection */
#define CON_HANG	0x10	/* Wants us to SIGHUP the pseudo if 
							 * the tcp connection drops
							 */
#define CON_RESOLVED	0x20	/* Set once the host name is resolved */
#define CON_LOST	0x40		/* Connection appears to be lost */
#define CON_TELNET	0x80		/* Connection uses telnet */


#define isPermanent(p) (((p)->conFlags) & CON_PERM)
#define isConnected(p) (((p)->conFlags) & CON_OPEN)

/*--------------------------
 * functions in iservcon.c
 *--------------------------
 */

extern int gotpipe ARGS(());
extern int initConnect ARGS((coninfo_t *, servopts_t *));
extern void endConnection ARGS((coninfo_t *));
extern void markLost ARGS((coninfo_t *, char *));
extern int attemptConnect ARGS((coninfo_t *));
extern void intrSignal ARGS((int, void (*)()) );
extern void deathOfChild ARGS(());


