/*
 *
 * $RCSfile: log.c,v $
 * $Revision: 1.6 $
 * $Date: 1998/08/24 17:04:43 $
 *
 * This will place anentry in the log file. This applies
 * only to the Job Manager (ss.o) module.
 *
 * $Header: //Iservd/log.c#1 $
 * 
 * $Log: log.c,v $
 * Revision 1.6  1998/08/24 17:04:43  chuckh
 * fixed preprocessor error encountered on NCR.
 *
 * Revision 1.5  1998/08/19 16:43:52  chuckh
 * sun specific changes
 *
 * Revision 1.4  1998/08/19 14:47:10  chuckh
 * sun specific changes
 *
 * Revision 1.3  1998/08/07 14:49:48  chuckh
 * Added RCS headers
 *
 */
#include <stdio.h>
#include <string.h>
#ifdef	SYSLOG
#include <syslog.h>
#endif
#include <varargs.h>

#include "ss.h"

#define	LOGBUF_SIZE	4096
/*
 * Define LOGOUT to be one of the well known stdxxx FILE pointers
 * all depending on where you want debuging and error message to go.
 * Typically, these will be redirected to a file anyway.
 * Use of stdout is preferred due to the extra overhead of a flush after
 * each write to stderr.  The FILE gets flushed after each *line* anyway.
 */
#define	LOGFP	stdout

static	int		inited = 0;
static	char	*logBuf = (char *) 0;


/*
 *
 * A simple interface to a logger.
 *
 * Right now, this just print to stdout.  Later, we can interface it to
 * syslog or something like that.
 */
void
Log(va_alist)
va_dcl
{
	int	level;
	char	*fmt;
	va_list	args;

	if (!inited)
	{
#ifdef	SYSLOG
		char	*progName;

		if (progName = strrchr(absArgv0, '/'))
			++progName;	/* Locate the 1st char of the program name */
		else
			progName = absArgv0;

		if ((logBuf = (char *) malloc(LOGBUF_SIZE)) == (char *) 0)
		{
			fprintf(stderr, "Can't allocate log buffer.\n");
			return;
		}
		openlog(progName, LOG_PID, LOG_DAEMON);
#endif
		inited = 1;
	}
	va_start(args);

	level = va_arg(args, int);
	fmt = va_arg(args, char *);

	if (debug >= level)
	{
#ifdef	SYSLOG
		int	syslogLevel;

#if defined(HP) || defined(SUN)
		/*
		 * memory corruption potential. here
		 * If the end string is bigger then LOGBUF_SIZE
		 * we'll get memory corruption.
		 */
		vsprintf(logBuf, fmt, args);
#else
		vsnprintf(logBuf, LOGBUF_SIZE, fmt, args);
#endif
		logBuf[LOGBUF_SIZE-1] = 0;

		switch (level)
		{
		case 1:	syslogLevel = LOG_ERR;			break;
		case 2: syslogLevel = LOG_INFO;;		break;
		case 3:	syslogLevel = LOG_DEBUG;		break;
		default:	syslogLevel = LOG_DEBUG;
		}
		syslog(syslogLevel+LOG_DAEMON, "%s", logBuf);
#else
		fprintf(LOGFP, "%s[%d]: ", absArgv0, getpid());
		vfprintf(LOGFP, fmt, args);
		fprintf(LOGFP, "\n");
		fflush(LOGFP);
#endif
	}
	va_end(args);
}
